---
title: EffectTiming.fill
slug: Web/API/EffectTiming/fill
tags:
  - API
  - Animation
  - EffectTiming
  - Experimental
  - KeyframeEffect
  - Property
  - Reference
  - Web Animations
  - animate
  - fill
  - web animations api
---
<div>{{ SeeCompatTable() }}{{ APIRef("Web Animations") }}</div>

<p>The <a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a>'s {{domxref("EffectTiming")}} dictionary's <strong><code>fill</code></strong> property specifies a <strong>fill mode</strong>, which defines how the element to which the animation is applied should look when the animation sequence is not actively running, such as before the time specified by {{domxref("AnimationEffectTimingProperties.iterationStart", "iterationStart")}} or after animation's end time.</p>

<p>For example, setting fill to <code>"none"</code> means the animation's effects are not applied to the element if the current time is outside the range of times during which the animation is running, while <code>"forwards"</code> ensures that once the animation's end time has been passed, the element will continue to be drawn in the state it was in at its last rendered frame.</p>

<p>Note that authors are discouraged from using fill modes to persist the effect of an animation indefinitely. See the <a href="#Alternatives_to_fill_modes">alternatives to fill modes section below</a> for approaches that are simpler and more performant.</p>

<div class="note">
<p>{{domxref("Element.animate()")}}, and {{domxref("KeyframeEffect.KeyframeEffect", "KeyframeEffect()")}} accept an object of timing properties including <code>fill.</code> The value of <code>fill</code> corresponds directly to {{domxref("EffectTiming.fill", "fill")}} in {{domxref("EffectTiming")}} objects returned by {{domxref("AnimationEffect.getTiming()", "getTiming()")}} in {{domxref("AnimationEffect")}} and {{domxref("KeyframeEffect")}}.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>timingProperties</em> = {
  fill: "none" | "forwards" | "backwards" | "both" | "auto"
}
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} indicating the fill type to use in order to properly render an affected element when outside the animation's <strong>active interval</strong> (that is, when it's not actively animating). The default is <code>"auto"</code>.</p>

<dl>
	<dt><code>"none"</code></dt>
	<dd>The animation's effects are only visible while the animation is iterating or its playhead is positioned over an iteration. The animation's effects are not visible when its {{domxref("Animation.playState", "playState")}} is <code>pending</code> with a {{domxref("AnimationEffectTimingReadOnly.delay", "delay")}}, when its <code>playState</code> is <code>finished</code>, or during its {{domxref("AnimationEffectTimingReadOnly.endDelay", "endDelay")}} or  {{domxref("AnimationEffectTimingReadOnly.delay", "delay")}}. In other words, if the animation isn't in its active interval, the affected element is not visible.</dd>
	<dt><code>"forwards"</code></dt>
	<dd>The affected element will continue to be rendered in the state of the final animation framecontinue to be applied to the  after the animation has completed playing, in spite of and during any {{domxref("AnimationEffectTimingReadOnly.endDelay", "endDelay")}} or when its <code>playState</code> is <code>finished</code>.</dd>
	<dt><code>"backwards"</code></dt>
	<dd>The animation's effects should be reflected by the element(s) state prior to playing, in spite of and during any {{domxref("AnimationEffectTimingReadOnly.delay", "delay")}} and <code>pending</code> {{domxref("Animation.playState", "playState")}}.</dd>
	<dt><code>"both"</code></dt>
	<dd>Combining the effects of <strong>both </strong><code>forwards</code> and <code>backwards</code>: The animation's effects should be reflected by the element(s) state prior to playing and retained after the animation has completed playing, in spite of and during any {{domxref("AnimationEffectTimingReadOnly.endDelay", "endDelay")}}, {{domxref("AnimationEffectTimingReadOnly.delay", "delay")}} and/or <code>pending</code> or <code>finished</code> {{domxref("Animation.playState", "playState")}}.</dd>
	<dt><code>"auto"</code></dt>
	<dd>If the animation effect the fill mode is being applied to is a keyframe effect ({{domxref("KeyframeEffect")}} or {{domxref("KeyframeEffectReadOnly")}}), <code>"auto"</code> is equivalent to <code>"none"</code>. Otherwise, the result is <code>"both"</code>.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>Here are a few examples.</p>

<h3 id="Fill_mode_none">Fill mode: none</h3>

<h4 id="HTML_content">HTML content</h4>

<p>The HTML is pretty simple. We have a {{HTMLElement("div")}} named <code>"main"</code> which is a container for the element we'll be animating, which is a <code>&lt;div&gt;</code> with the ID <code>"box"</code>. Below that, another <code>&lt;div&gt;</code> serves as a button that will trigger the animation to begin.</p>

<pre class="brush: html">&lt;div class="main"&gt;
  &lt;div id="box"&gt;
    &lt;div id="text"&gt;Look! A box!&lt;/div&gt;
  &lt;/div&gt;
&lt;/div&gt;
&lt;div class="button" id="animateButton"&gt;
  Animate!
&lt;/div&gt;
</pre>

<div class="hidden">
<h4 id="CSS_content">CSS content</h4>

<pre class="brush: css">.main {
  width: 300px;
  height:300px;
  border: 1px solid black;
}

.button {
  cursor: pointer;
  width: 300px;
  border: 1px solid black;
  font-size: 16px;
  text-align: center;
  margin-top: 0px;
  padding-top: 2px;
  padding-bottom: 4px;
  color: white;
  background-color: darkgreen;
  font: 14px "Open Sans", "Arial", sans-serif;
}

#text {
  width: 160px;
  padding: 10px;
  position: relative;
  text-align: center;
  align-self: center;
  color: white;
  font: bold 2em "Lucida Grande", "Open Sans", sans-serif;
}</pre>
</div>

<p>While there's other CSS involved in this example, the part that really matters for our purposes is the CSS that styles the <code>"box"</code> element that we'll be animating. That CSS looks like this:</p>

<pre class="brush: css">#box {
  width: 200px;
  height: 200px;
  left: 50px;
  top: 50px;
  border: 1px solid #7788FF;
  margin: 0;
  position: relative;
  background-color: #2233FF;
  display: flex;
  justify-content: center;
}</pre>

<p>All this does is specify the size, border, and color information, as well as indicate that the box should be centered both vertically and horizontally inside its container. Note that there's no rotation applied.</p>

<h4 id="JavaScript_content">JavaScript content</h4>

<p>Now let's check out the JavaScript. First we'll define the two objects that describe the keyframes and the timing configuration to use, then we'll actually see the code that triggers and runs the animation when the <code>"animateButton"</code> button is clicked.</p>

<pre>var boxRotationKeyframes = [
  { transform: "rotate(-90deg)" },
  { transform: "rotate(90deg)" }
];
</pre>

<p>The <code>boxRotationKeyframes</code> object is an array of keyframes, each describing the state of the affected element at a point in the animation process. In this case, we have just two keyframes; the first defines what affect is applied to the element <em>immediately after the animation first begins to play</em>, and the second defines the effect applied to the element in the <em>last moment before it ends</em>. Those phrases are crucial. Let's look at why.</p>

<p>The first keyframe says that when the animation begins, the element should be rotated 90° to the left. That means that unless we specify otherwise using the <code>fill</code> property, the instant the animation is started the element will be rotated to the left 90°, and then it will animate smoothly from there. Since by default the box isn't rotated,</p>

<p>The last keyframe says that the animation's final frame should draw the animation rotated 90° to the right from its original orientation.</p>

<pre class="brush: js">var boxRotationTiming = {
  duration: 2000,
  iterations: 1,
  fill: "none"
};</pre>

<p>The <code>boxRotationTiming</code> object describes how long the animation should take to run, how many times it should run, what state the element should be in before the animation begins and after it ends, and so forth.</p>

<p>Here we specify that the animation should take 2000 milliseconds (2 seconds) to complete, should only run once, and that the fill mode should be <code>"none"</code>. As defined above, the <code>"none"</code> fill mode means that the element will be rendered in its natural, unaltered condition anytime the animation isn't actively running.</p>

<pre class="brush: js">document.getElementById("animateButton").addEventListener("click", event =&gt; {
  document.getElementById("box").animate(
    boxRotationKeyframes,
    boxRotationTiming
  );
}, false);</pre>

<p>The rest of the code is pretty simple: it adds an event listener to the "Animate" button so that when it's clicked by the user, the box is animated by calling {{domxref("Element.animate()")}} on it, providing the <code>boxRotationKeyframes</code> and <code>boxRotationTiming</code> objects to describe the animation that should occur.</p>

<h3 id="Result">Result</h3>

<p>Below we see what the result looks like. Notice how before the animation starts running, the box is upright, then upon clicking the "Animate!" button, the box is instantly rotated 90° to the left (to correspond to the first keyframe in the animation sequence). Then, when the animation finishes running, the box instantaneously leaps back to its original state and is upright once again.</p>

<p>Give it a try below!</p>

<p>{{ EmbedLiveSample('Fill_mode_none', 320, 320) }}</p>

<h3 id="Follow_the_White_Rabbit_example">Follow the White Rabbit example</h3>

<p>In the <a href="http://codepen.io/rachelnabors/pen/eJyWzm?editors=0010">Follow the White Rabbit</a> example, the White Rabbit's animation is formed by coupling a <code>KeyframeEffect</code> with an <code>Animation</code> object. The <code>keyframeEffect</code> takes an object of <a href="/en-US/docs/Web/API/Web_Animations_API/Animation_timing_options">timing properties</a>, which is where we pass in <code>fill</code>. <code>Forwards</code> makes the rabbit retain its last keyframe rather than reverting to its unanimated state:</p>

<pre class="brush: js">// Create a set of keyframes to slide the rabbit down the hole--and keep him down with 'fill'!
var rabbitDownKeyframes = new KeyframeEffect(
  whiteRabbit,
  [
    { transform: 'translateY(0%)' },
    { transform: 'translateY(100%)' }
  ], {
    duration: 3000,
    fill: 'forwards'
  }
);

// Set up the rabbit's animation to play on command by calling rabbitDownAnimation.play() later
var rabbitDownAnimation = new Animation(rabbitDownKeyframes, document.timeline);
</pre>

<h2 id="Alternatives_to_fill_modes">Alternatives to fill modes</h2>

<p>Fill modes are primarily provided as a means of representing the <a href="/en-US/docs/Web/CSS/animation-fill-mode">animation-fill-mode</a> feature of CSS animations. When used to persist the effect of an animation indefinitely, however, they have a number of drawbacks:</p>

<ul>
	<li>The forwards fill of an animation (or backwards fill if the animation is playing in reverse) will continue to override any changes to specified style indefinitely which can lead to confusing behavior. This is because animations take priority in the <a href="/en-US/docs/Web/CSS/Cascade#Cascading_order">CSS cascade</a> over normal author styles.</li>
	<li>In order to avoid leaking memory when many filling animations overlap, the browser is required to remove overlapped animations which can lead to surprising results in some cases.</li>
</ul>

<p>Rather than using fill modes to persist an animation, it is often simpler to set the final value of the animation effect directly in specified style:</p>

<pre class="brush: js">elem.animate({ transform: 'translateY(100px)' }, 200).finished.then(() =&gt; {
  elem.style.transform = 'translateY(100px)';
});
</pre>

<p>Alternatively, it may be simpler still to set the final value in specified style before triggering the animation and then animate <em>from</em> the start value. This is the approach used in <a href="https://aerotwist.com/blog/flip-your-animations/">FLIP animation</a>.</p>

<pre class="brush: js">elem.style.transform = 'translateY(100px)';
elem.animate({ transform: 'none', offset: 0 }, 200);
</pre>

<p>For some complex effects where animations layer on top of one another, it may be necessary to use a fill mode temporarily to capture the final value of an animation before canceling it.</p>

<pre class="brush: js">elem.addEventListener('click', async evt =&gt; {
  const animation = elem.animate(
    { transform: `translate(${evt.clientX}px, ${evt.clientY}px)` },
    { duration: 800, fill: 'forwards' }
  );
  await animation.finished;
  // commitStyles will record the style up to and including `animation` and
  // update elem’s specified style with the result.
  animation.commitStyles();
  animation.cancel();
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('Web Animations', '#enumdef-fillmode', 'fill' )}}</td>
			<td>{{Spec2('Web Animations')}}</td>
			<td>Editor's draft.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.EffectTiming.fill")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web/API/Web_Animations_API">Web Animations API</a></li>
	<li>{{domxref("Element.animate()")}} and {{domxref("KeyframeEffect.KeyframeEffect()")}} both accept an object of timing properties including this one.</li>
	<li>The value of this property corresponds to the one in {{domxref("EffectTiming")}} as returned by {{domxref("AnimationEffect.getTiming()", "getTiming()")}} in {{domxref("AnimationEffect")}} and {{domxref("KeyframeEffect")}}.</li>
	<li>CSS's <code><a href="/en-US/docs/Web/CSS/animation-fill-mode">animation-fill-mode</a></code></li>
</ul>
